/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package weka.gui.experiment;
import java.awt.Color;
import java.awt.Graphics;
//import java.util.Iterator;

import java.util.Calendar;

import javax.swing.JPanel;

import java.io.*;

/**
 *
 * @author Owner
 */
public class GrPanel extends JPanel {
    public double[][] matrix;
    protected Integer m_plotAreaWidth;
    protected Integer m_plotAreaHeight;  
    protected boolean m_IdealIncluded;
    protected int  m_linesCounter;
    protected int m_algorithmsNumber; 
    protected int m_datasetsNumber;
    protected int m_measuresNumber;
    protected String m_duplicate;
    
	public GrPanel(int w,int h)
	{
		this.setSize(w,h);                
                m_plotAreaWidth=w;
                m_plotAreaHeight=h;               
                m_IdealIncluded=false;
                m_linesCounter=0;
                m_algorithmsNumber=0; 
                m_datasetsNumber=0;
                m_measuresNumber=0;
                m_duplicate="";
	}
        public void runMDS(String mode,String metric, int  linesCounter, int algorithmsNumber, int datasetsNumber, int measuresNumber, String duplicate) {
           
           if(mode.equals("advanced"))
               m_IdealIncluded=true;
           else 
               m_IdealIncluded=false;
           
            m_linesCounter= linesCounter;
            m_algorithmsNumber=algorithmsNumber; 
            m_datasetsNumber=datasetsNumber;
            m_measuresNumber=measuresNumber;
            m_duplicate=duplicate; //Actually, m_duplicates is not more in use, could be discard
            if((m_linesCounter>2)&&(m_algorithmsNumber>0)&&(m_datasetsNumber>0)&&(m_measuresNumber>0)&&(m_duplicate.equals("")))
                callJRIprocess(metric);    
      }
        
        public void paintComponent(Graphics g) {
             if((m_linesCounter>2)&&(m_algorithmsNumber>0)&&(m_datasetsNumber>0)&&(m_measuresNumber>0)&&(m_duplicate.equals("")))              
                paintGrafic(g);
            else
                paintErrorMessage(g);            
      }
     
        protected void callJRIprocess (String metric){
            try{
                Calendar cal = Calendar.getInstance();
                Long timestampL=cal.getTimeInMillis();
                String timestamp="AAA"+timestampL.toString();       
                Process pp = Runtime.getRuntime().exec("java -Xmx1024m -cp CLASSPATH -jar JRItest.jar rtest MDScoord.txt "+timestamp+" '"+metric+"'");       
                boolean notDone=true;          
                int dotsNumber=0;
                File file = new File("MDScoord.txt");
                while(notDone){
                    dotsNumber=0;       
                    if(file.exists()){
                        BufferedReader br = new BufferedReader(new FileReader(file));  
                        String line = null;
                        while((line = br.readLine()) != null){
                             if(line.equals(timestamp))
                                 notDone=false;                                          
                             else
                                 dotsNumber++; 
                            }        
                       } 
                 }
                 matrix=new double[dotsNumber][2];
                 BufferedReader br = new BufferedReader(new FileReader(file));  
                 String line = null;
                 for(int i=0;i<dotsNumber;i++){
                      line = br.readLine();
                      int pos=line.indexOf(',');
                      matrix[i][0]=Double.parseDouble(line.substring(0, pos));
                      matrix[i][1]=Double.parseDouble(line.substring( pos+1));
                 }   
            
             }catch(Exception e){
                e.getMessage(); e.printStackTrace();  
            }          
        }
     
     protected void paintGrafic(Graphics g){
         double xMax=Double.MIN_VALUE;
         double xMin=Double.MAX_VALUE;
         double yMax=Double.MIN_VALUE;
         double yMin=Double.MAX_VALUE;
         for(int i=0;i<matrix.length;i++){
           if(matrix[i][0]>xMax)
               xMax=matrix[i][0];
           if(matrix[i][0]<xMin)
               xMin=matrix[i][0];
           if(matrix[i][1]>yMax)
               yMax=matrix[i][1];
           if(matrix[i][1]<yMin)
               yMin=matrix[i][1];
         }
         double shiftX=0.0;
         if(xMin<0)
             shiftX=(-1)*xMin;
         double shiftY=0.0;
         if(yMin<0)
             shiftY=(-1)*yMin;
         double kX=m_plotAreaWidth/(xMax-xMin);
         if(kX<0)
             kX=(-1)*kX;
         double kY=m_plotAreaHeight/(yMax-yMin);
         if(kY<0)
             kY=(-1)*kY;
       try{  
           Integer count=1;         
           FileOutputStream out;
           PrintStream p; 
           out = new FileOutputStream("Coordinate2_Log.txt");
           p = new PrintStream( out );
           super.paintComponent(g);
           g.setColor(Color.black); 
           
           if(m_IdealIncluded){
              //build ideal pole and circles
               Double xx= kX * (matrix[0][0]+shiftX);                                          
               int x=xx.intValue();
               Double yy= kY * (matrix[0][1]+shiftY);                                          
               int y=yy.intValue();
              
               g.setColor(Color.black);
               g.drawOval(x, y, 3, 3);
               g.setColor(Color.LIGHT_GRAY);
              
               int maxRad=m_plotAreaWidth+100;
               int incr=20;
               int k=0;
                
               for(int i=0;i<maxRad;i=i+incr){
                   if(k==5){
                       g.setColor(Color.darkGray); 
                       k=0;
                   } 
                  g.drawOval(x-i, y-i, i*2, i*2);
                  g.setColor(Color.LIGHT_GRAY);
                  k++;                   
               }
               count--;
             }
           
             for(int i=0;i<matrix.length;i++)
                {                     
                      Double xx= kX * (matrix[i][0]+shiftX);                                          
                      int x=xx.intValue();
                      Double yy= kY * (matrix[i][1]+shiftY);                                          
                      int y=yy.intValue();
                      
                      drawNode(g,i, x, y);
                      drowLabel(g,i, x, y);
                      
                      p.println("count="+i+"  x="+x+"  y="+y); 
                }             
               }catch(Exception e){
                e.getMessage();
            } 
     }
     
      protected void paintErrorMessage(Graphics g){
          super.paintComponent(g);
          g.setColor(Color.blue);
          String errorMesage="";
          
          if(m_linesCounter<3){
              errorMesage="You have only "+m_linesCounter+" experements schemes selected for Visualization";
              g.drawString(errorMesage, 20, 50);
              errorMesage="At least 3 experiments schemes or 2 experiments schemes + Ideal are requered ";
              g.drawString(errorMesage, 20, 80);
              errorMesage="to be selected for successful Visualization ";
              g.drawString(errorMesage, 20, 100);
          }
          
          if(m_algorithmsNumber<1){
              errorMesage="At least one algorithm should be selected for successful Visualization ";
              g.drawString(errorMesage, 20, 120);
          }
          
          if(m_datasetsNumber<1){
              errorMesage="At least one data set should be selected for successful Visualization ";
              g.drawString(errorMesage, 20, 140);
          }
          
          if(m_measuresNumber<1){
              errorMesage="At least one performance measure should be selected for successful Visualization ";
              g.drawString(errorMesage, 20, 160);
          }
          
          if(!m_duplicate.equals("")){//Actually, m_duplicates is not more in use, could be discard
              errorMesage="All items in Algorithms and Datasets list  should be unique. The input "+m_duplicate+" is not unique";
              g.drawString(errorMesage, 20, 160);          
          }
      }
     
     
     protected void drawNode(Graphics g,Integer count, int x,int y){
         if(m_IdealIncluded)
             count--;
         g.setColor(Color.magenta);         
         if(count>-1)        
                      g.drawRect(x,y,3,3);
     };
     
     protected void drowLabel(Graphics g, Integer count, int x,int y){
         if(m_IdealIncluded)
             count--;
         g.setColor(Color.blue);
         if(count>-1)
             g.drawString(count.toString(), x+6, y+8);
         else
             g.drawString("Ideal", x+4, y+4);
     }
}
